import os


# Find dirs
INSTANCE_DIR = None
FAKEHOME_DIR = None
CONFIG_DIR = None
BACKUP_DIR = None
DOWNLOADS_DIR = None
VOLUME_DIR = None
if os.environ.get("XDG_CACHE_HOME", None) is not None:
    # Check if in flatpak
    if os.environ.get("FLATPAK_ID", None) is None:
        tmp = os.path.join(os.environ.get("XDG_CACHE_HOME"), "winestarter")
    else:
        tmp = os.environ.get("XDG_CACHE_HOME")

    # Set paths for backup and downloads
    if BACKUP_DIR is None:
        BACKUP_DIR = os.path.join(tmp, "backups")
    if DOWNLOADS_DIR is None:
        DOWNLOADS_DIR = os.path.join(tmp, "downloads")
    del tmp
if os.environ.get("XDG_CONFIG_HOME", None) is not None:
    # Check if in flatpak
    if os.environ.get("FLATPAK_ID", None) is None:
        tmp = os.path.join(os.environ.get("XDG_CONFIG_HOME"), "winestarter")
    else:
        tmp = os.environ.get("XDG_CONFIG_HOME")

    # Set paths for config dir
    if CONFIG_DIR is None:
        CONFIG_DIR = os.path.join(tmp, "config")
    del tmp
if os.environ.get("XDG_DATA_HOME", None) is not None:
    # Check if in flatpak
    if os.environ.get("FLATPAK_ID", None) is None:
        tmp = os.path.join(os.environ.get("XDG_DATA_HOME"), "winestarter")
    else:
        tmp = os.environ.get("XDG_DATA_HOME")

    # Set paths for instances, fakehomes, config, backups and downloads
    if INSTANCE_DIR is None:
        INSTANCE_DIR = os.path.join(tmp, "instances")
    if FAKEHOME_DIR is None:
        FAKEHOME_DIR = os.path.join(tmp, "fakehomes")
    if CONFIG_DIR is None:
        CONFIG_DIR = os.path.join(tmp, "config")
    if BACKUP_DIR is None:
        BACKUP_DIR = os.path.join(tmp, "backups")
    if DOWNLOADS_DIR is None:
        DOWNLOADS_DIR = os.path.join(tmp, "downloads")
    if VOLUME_DIR is None:
        VOLUME_DIR = os.path.join(tmp, "volumes")
    del tmp
if os.environ.get("HOME", None):
    # As backup the home dir
    tmp = os.path.join(os.environ.get("HOME"), ".winestarter")
    if INSTANCE_DIR is None:
        INSTANCE_DIR = os.path.join(tmp, "instances")
    if FAKEHOME_DIR is None:
        FAKEHOME_DIR = os.path.join(tmp, "fakehomes")
    if CONFIG_DIR is None:
        CONFIG_DIR = os.path.join(tmp, "config")
    if BACKUP_DIR is None:
        BACKUP_DIR = os.path.join(tmp, "backups")
    if DOWNLOADS_DIR is None:
        DOWNLOADS_DIR = os.path.join(tmp, "downloads")
    if VOLUME_DIR is None:
        VOLUME_DIR = os.path.join(tmp, "volumes")
    del tmp
if None in (INSTANCE_DIR, FAKEHOME_DIR, CONFIG_DIR, BACKUP_DIR, DOWNLOADS_DIR, VOLUME_DIR):
    print(repr((INSTANCE_DIR, FAKEHOME_DIR, CONFIG_DIR, BACKUP_DIR, DOWNLOADS_DIR, VOLUME_DIR)))
    raise ValueError("Can't find HOME or XDG_DATA_HOME")


# Create paths
INSTANCE_DIR = os.path.abspath(INSTANCE_DIR)
FAKEHOME_DIR = os.path.abspath(FAKEHOME_DIR)
CONFIG_DIR = os.path.abspath(CONFIG_DIR)
BACKUP_DIR = os.path.abspath(BACKUP_DIR)
DOWNLOADS_DIR = os.path.abspath(DOWNLOADS_DIR)
VOLUME_DIR = os.path.abspath(VOLUME_DIR)
os.makedirs(INSTANCE_DIR, exist_ok=True)
os.makedirs(FAKEHOME_DIR, exist_ok=True)
os.makedirs(CONFIG_DIR, exist_ok=True)
os.makedirs(BACKUP_DIR, exist_ok=True)
os.makedirs(DOWNLOADS_DIR, exist_ok=True)
os.makedirs(VOLUME_DIR, exist_ok=True)
